<template>
  <div class="row mt-3 justify-content-center">
    <div class="col-10">
      <table class="table table-striped" v-if="hayLiqDetalles">
        <thead>
          <tr class="bg-principal text-light fs-4 text-uppercase text-center">
            <th scope="col" style="padding: 15px 10px !important">Per&iacute;odo Liq.</th>
            <th scope="col" style="padding: 15px 10px !important">Mes Pago</th>
            <th scope="col" style="padding: 15px 10px !important">Importe Liq.</th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="liqDetalle in liqDetallesStore.getLiqDetalles()" :key="liqDetalle.id_liq_deta">
            <td class="pt-2 pb-1 px-2 text-center" v-text='fechaMostrar(liqDetalle.f_periodo)'></td>
            <td class="pt-2 pb-1 px-2 text-center" v-text='mesMostrar(liqDetalle.mes_pag)'></td>
            <td class="pt-2 pb-1 px-2 text-right" v-text='importeMostrar(liqDetalle.importe)'></td>
          </tr>
        </tbody>
      </table>
      <div v-else class="alert alert-secondary text-center" role="alert">
        No se ha encontrado ning&uacute;n per&iacute;odo liquidado de esta beca en el sistema.
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">

// Librerias
import { DateTime } from "luxon";
import { reactive, computed, ref, toRef, watch, watchEffect, onMounted } from "vue";
import type { Ref } from "vue";
import { AutoComplete, InputExpediente, Expediente, Modal } from "@hcd-bsas/vue3-components";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { SweetAlertOptions, SweetAlertResult } from "sweetalert2";
import http from "@/http";
import type { AxiosResponse, AxiosError } from "axios";
import { urlApi, urlComun, isEmpty, loading } from "@/shared.js";
// Stores
import { useLiqDetallesStore } from "@/stores/becas/liqDetalles";

const liqDetallesStore = useLiqDetallesStore();

const props = withDefaults(defineProps<{
  idBeca: number
}>(), {
  idBeca: NaN
});

const emits = defineEmits(["cerrar"]);

const rangoNumeros = (inicio: number, fin: number) => Array.from(Array(fin - inicio + 1).keys()).map((numero: number) => numero + inicio);
const importeMostrar = (importe: number | undefined) => (!isEmpty(importe)) ? Intl.NumberFormat("es-AR", { style: 'currency', currency: 'ARS', minimumFractionDigits: 2 }).format(importe!) : null;
const fechaPriDiaMes = (fecha: string) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha).startOf('month').toFormat('yyyy-MM-dd') : "";
const fechaUltDiaMes = (fecha: string) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha).endOf('month').toFormat('yyyy-MM-dd') : "";
const fechaSigMes = (fecha: string) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha).plus({ months: 1 }).toFormat('yyyy-MM-dd') : "";
const fechaMostrar = (fecha: string | null) => (fecha !== null) ? DateTime.fromISO(fecha).toFormat('dd/MM/yyyy') : "";
const fechaGetMes = (fecha: string) => (!isEmpty(fecha)) ? DateTime.fromISO(fecha).month : NaN;
const mesMostrar = (mes: number | undefined) => (!isEmpty(mes)) ? DateTime.fromObject({ month: mes }, { locale: 'es-AR' }).toFormat('MM (MMMM)') : "";

const hayLiqDetalles = computed(() => !isEmpty(liqDetallesStore.getLiqDetalles()));

onMounted(async () => {
  loading.show();
  await cargar();
  loading.hide();
});

async function cargar() {
  const paramsRequest: Object = {
    id_beca: props.idBeca
  };
  const promiseLiqDetalles: Promise<boolean> = liqDetallesStore.fetchLiqDetalles(paramsRequest);
  await promiseLiqDetalles.then((exito) => {
    if (!exito) {
      cerrar();
    }
    //loading.hide();
  }).catch(() => {
    //loading.hide();
  });
}

function cerrar() {
  emits("cerrar");
}

</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
